package it.inaf.oats.ia2.tapschemamanager.webapp;

import it.inaf.oats.ia2.tapschemamanager.businesslayer.CredentialsConfiguration;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import javax.annotation.PostConstruct;
import javax.enterprise.context.ApplicationScoped;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.xml.bind.JAXB;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author Sonia Zorba {@literal <zorba at oats.inaf.it>}
 */
@ApplicationScoped
public class CredentialsConfigurationBean {

    private static final Logger log = LoggerFactory.getLogger(CredentialsConfigurationBean.class);

    private String credentialsConfigPath;
    private CredentialsConfiguration cc;

    @PostConstruct
    public void init() {
        try {
            InitialContext ic = new InitialContext();
            credentialsConfigPath = (String) ic.lookup("java:comp/env/CREDENTIALS_CONFIG_PATH");

            log.debug("CREDENTIALS_CONFIG_PATH={}", credentialsConfigPath);

            cc = JAXB.unmarshal(new File(credentialsConfigPath), CredentialsConfiguration.class);

        } catch (NamingException e) {
            throw new RuntimeException(e);
        }
    }

    public CredentialsConfiguration getConfig() {
        return cc;
    }

    public void updateConfigurationFile() throws IOException {
        FileWriter fw = new FileWriter(credentialsConfigPath);
        JAXB.marshal(cc, fw);
        fw.close();
    }
}
