package it.inaf.oats.ia2.tapschemamanager.datalayer;

/**
 * Interface that represents one of the principal entities of the TAP_SCHEMA, so
 * it can be an instance of {@link SchemaEntity}, {@link TableEntity} or
 * {@link ColumnEntity}.
 *
 * {@link KeyEntity} and {@link KeyColumnEntity} aren't included because their
 * management is different.
 *
 * @author Sonia Zorba {@literal <zorba at oats.inaf.it>}
 */
public interface TapSchemaEntity {

    /**
     * It can be the schema name, the table name or the column name.
     *
     * @return the name of the entity
     */
    String getName();
}
